/*=============================================================================*
 *  Copyright 2005 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.mows.v1_0;

/**
 * Constants for names defined by the MOWS 1.0 specification.
 */
public interface MowsConstants
{

    /**
     * The base URI for all URIs defined by the MOWS spec.
     */
    String BASE_URI_MOWS = "http://docs.oasis-open.org/wsdm/2004/12/mows/";

    /**
     * The base URI for all manageability capability URIs defined by the MOWS spec.
     */
    String BASE_URI_MOWS_CAPABILITIES = BASE_URI_MOWS + "capabilities/";

    /**
     * Namespace URI for MOWS schema.
     */
    String NSURI_MOWS_SCHEMA = BASE_URI_MOWS + "wsdm-mows.xsd";

    /**
     * Namespace prefix for MOWS schema.
     */
    String NSPREFIX_MOWS_SCHEMA = "mows-xs";

    /**
     * Namespace URI for MOWS WSDL.
     */
    String NSURI_MOWS_WSDL = BASE_URI_MOWS + "wsdm-mows.wsdl";

    /**
     * Namespace prefix for MOWS WSDL.
     */
    String NSPREFIX_MOWS_WSDL = "mows-wsdl";

    /**
     * Namespace URI for MOWS topics.
     */
    String NSURI_MOWS_TOPICS = BASE_URI_MOWS + "wsdm-mows-events.xml";

    /**
     * Namespace prefix for MOWS topics.
     */
    String NSPREFIX_MOWS_TOPICS = "mows-events";
    
}
