/*=============================================================================*
 *  Copyright 2005 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.muws.tool;

import org.apache.ws.muws.tool.v1_0.RelationshipsPortType2JavaInfo;
import org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl;
import org.apache.ws.notification.tool.WsnWsdl2Java;
import org.apache.ws.mows.tool.v1_0.ManageabilityReferencesPortType2JavaInfo;
import org.apache.ws.resource.tool.velocity.ServiceProperties;
import org.apache.ws.resource.ResourceDefinition;
import org.apache.velocity.VelocityContext;

import java.io.File;

/**
 * TODO
 */
public class MuwsWsdl2Java extends WsnWsdl2Java
{
    protected String WEBAPP_NAME = "muse";

    public MuwsWsdl2Java( File[] wsdlFiles, File outputDir, File[] classpath, Wsdl2JavaOptions options )
            throws Exception
    {
        super( wsdlFiles, outputDir, classpath, options );
        initPortTypeInfoMap();
    }
    protected String getWebbappName()
    {
        return WEBAPP_NAME;
    }

    private void initPortTypeInfoMap()
    {
        addPortType2JavaInfo( new RelationshipsPortType2JavaInfo() );
        addPortType2JavaInfo( new ManageabilityReferencesPortType2JavaInfo() );
    }

    protected ServiceProperties buildServiceProperties(ResourceDefinition resourceDefinition, File file, File file1)
    {
        ServiceProperties serviceProperties = super.buildServiceProperties(resourceDefinition, file, file1);
        serviceProperties.setNamespaceVersionHolder(WsdmNamespaceVersionHolderImpl.class);//make sure to add different ones as new versions comeout
        return serviceProperties;
    }

    /**
     * Provides a hook for adding to the Velocity Context.
     *
     * @param context
     * @return VelocityContext
     */
    protected VelocityContext updateVelocityContext(VelocityContext context, ResourceDefinition resourceDef)
    {
        return super.updateVelocityContext(context, resourceDef);
    }
}
