package org.apache.ws.muws.v1_0.capability;

import org.apache.ws.muws.v1_0.MuwsConstants;

import javax.xml.namespace.QName;

/**
 * The MUWS Advertisement manageability capability.
 *
 * @author Sal Campana
 */
public interface AdvertisementCapability
{
    /**
     * Name of this capability.
     */
    String NAME = "Advertisement";


    /**
     * Manageability capability URI.
     */
    String URI = MuwsConstants.BASE_URI_MUWS_CAPABILITIES + NAME;

    /**
     * Topic names.
     */
    String TOPIC_MANAGEABILITY_ENPOINT_CREATION_NAME = "ManageabilityEndpointCreation";

    String TOPIC_MANAGEABLE_RESOURCE_CREATION_NAME = "ManageableResourceCreation";

    String TOPIC_MANAGEABILITY_ENPOINT_DESTRUCTION_NAME = "ManageabilityEndpointDestruction";

    String TOPIC_MANAGEABLE_RESOURCE_DESTRUCTION_NAME = "ManageableResourceDestruction";


}
