package org.apache.ws.muws.v1_0.capability;

import org.apache.ws.muws.v1_0.MuwsConstants;
import javax.xml.namespace.QName;

/**
 * The MUWS Configuration manageability capability.
 *
 * @author Sal Campana
 */
public interface ConfigurationCapability
{

    /**
     * Name of this capability.
     */
    String NAME = "Configuration";

    /**
     * Port type name.
     */
    QName PORT_TYPE_NAME = new QName( MuwsConstants.NSURI_MUWS_PART2_WSDL, NAME, MuwsConstants.NSPREFIX_MUWS_PART2_WSDL );

    /**
     * Manageability capability URI.
     */
    String URI = MuwsConstants.BASE_URI_MUWS_CAPABILITIES + NAME;

    /**
     * Topic name.
     */
    String TOPIC_NAME = NAME + "Capability";


}
