package org.apache.ws.muws.v1_0.events.impl;

import org.apache.ws.muws.v1_0.events.SubstitutionalMsg;
import org.apache.ws.XmlObjectWrapper;
import org.apache.xmlbeans.XmlObject;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.SubstitutableMsgType;

import java.util.List;
import java.util.ArrayList;


/**
 * @author Sal Campana
 */
public class SubstitutionalMsgImpl implements SubstitutionalMsg, XmlObjectWrapper
{
    private String m_messageId;
    private String m_msgType;
    private List m_values = new ArrayList();


    public void setMsgId(String messageId)
    {
        m_messageId = messageId;
    }

    public void setMsgType(String msgType)
    {
        m_msgType = msgType;
    }

    public void addValue(String value)
    {
       m_values.add(value);
    }

    public String getMsgId()
    {
        return m_messageId;
    }

    public String getMsgType()
    {
        return m_msgType;
    }

    public String[] getValueArray()
    {
        return (String[]) m_values.toArray(new String[0]);
    }

    public XmlObject getXmlObject()
    {        
        SubstitutableMsgType substitutableMsgType = SubstitutableMsgType.Factory.newInstance();
        substitutableMsgType.setMsgId(m_messageId);
        substitutableMsgType.setMsgIdType(m_msgType);
        for (int i = 0; i < m_values.size(); i++)
        {
            String s = (String) m_values.get(i);
            org.apache.xmlbeans.XmlAnySimpleType xmlAnySimpleType = substitutableMsgType.addNewValue();
            xmlAnySimpleType.setStringValue(s);
        }
        return substitutableMsgType;
    }
}
