
package org.apache.ws.muws.v1_0.impl.advertiser;

import org.apache.ws.resource.Resource;
import org.apache.ws.resource.ResourceContext;
import org.apache.ws.resource.ResourceContextException;
import org.apache.ws.resource.ResourceException;
import org.apache.ws.resource.ResourceKey;
import org.apache.ws.resource.ResourceUnknownException;
import org.apache.ws.resource.impl.AbstractResourceHome;
import org.apache.ws.addressing.EndpointReference;

import javax.xml.namespace.QName;

import java.io.Serializable;

/**
 * Home for ResourceAdvertiser WS-Resources.
 */
public class ResourceAdvertiserHome
        extends AbstractResourceHome
        implements Serializable
{

    /**  The service endpoint name as registered with the SOAP Platform.  This is useful for building EPR's. **/
    public static final QName SERVICE_NAME = javax.xml.namespace.QName.valueOf("{http://ws.apache.org/muws/advertiser/base/service/}ResourceAdvertiser");

    /** The management PortType associated with this resource. This is useful for building EPR's.**/
    public static final QName PORT_TYPE = javax.xml.namespace.QName.valueOf("{http://ws.apache.org/muws/advertiser/base/service/}AdvertiserPortType");

    /** The WSDL Port name associated with the resource. This is useful for building EPR's. **/
    public static final String PORT_NAME = "ResourceAdvertiser";

    /** The name of the resource key for this resource. **/
    public static final QName RESOURCE_KEY_NAME = javax.xml.namespace.QName.valueOf("{${resourcekey.NamespaceURI}}${resourcekey.LocalPart}");

        /**
     * A NamespaceVerionHolder which maintains the QNames of Spec Wsdls
     */
     public static final org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl SPEC_NAMESPACE_SET = new org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl();
        /** A constant for the JNDI Lookup name for this home. **/
    public static final String  HOME_LOCATION =
     org.apache.ws.resource.JndiConstants.CONTEXT_NAME_SERVICES + "/" + SERVICE_NAME.getLocalPart() + "/" + org.apache.ws.resource.JndiConstants.ATOMIC_NAME_HOME;
    private ResourceAdvertiserResource m_resource;

    /**
     *
     * @param resourceContext
     *
     * @return A Resource
     *
     * @throws ResourceException
     * @throws ResourceContextException
     * @throws ResourceUnknownException
     */
    public Resource getInstance( ResourceContext resourceContext )
            throws ResourceException,
            ResourceContextException,
            ResourceUnknownException
    {

        if (m_resource == null)
        {
            m_resource = new ResourceAdvertiserResource();
            m_resource.init();
        }

        return m_resource;

    }

    public QName getServiceName()
    {
        return SERVICE_NAME;
    }

    public QName getPortType()
    {
        return PORT_TYPE;
    }

    public String getServicePortName()
    {
        return PORT_NAME;
    }

    public QName getResourceKeyNameQName()
    {
        return RESOURCE_KEY_NAME;
    }
}
