package com.dell.wsdm.demos.interop.x2005.x04;

import org.apache.ws.resource.Resource;
import org.apache.ws.resource.ResourceContext;
import org.apache.ws.resource.ResourceContextException;
import org.apache.ws.resource.ResourceException;
import org.apache.ws.resource.ResourceKey;
import org.apache.ws.resource.ResourceUnknownException;
import org.apache.ws.resource.impl.AbstractResourceHome;
import org.apache.ws.addressing.EndpointReference;

import javax.xml.namespace.QName;
import java.io.Serializable;

/**
 * Home for Ipmiserver WS-Resources.
 */
public class IpmiserverHome
        extends AbstractResourceHome
        implements Serializable
{

    /**
     * The service endpoint name as registered with the SOAP Platform.  This is useful for building EPR's. *
     */
    public static final QName SERVICE_NAME = javax.xml.namespace.QName.valueOf("{http://dell.com/wsdm/demos/interop/2005/04}ipmiserver");

    /**
     * The management PortType associated with this resource. This is useful for building EPR's.*
     */
    public static final QName PORT_TYPE = javax.xml.namespace.QName.valueOf("{http://dell.com/wsdm/demos/interop/2005/04}IPMIServerPortType");

    /**
     * The WSDL Port name associated with the resource. This is useful for building EPR's. *
     */
    public static final String PORT_NAME = "ipmiserver";

    /**
     * The name of the resource key for this resource. *
     */
    public static final QName RESOURCE_KEY_NAME = javax.xml.namespace.QName.valueOf("{${resourcekey.NamespaceURI}}${resourcekey.LocalPart}");

    /**
     * A NamespaceVerionHolder which maintains the QNames of Spec Wsdls
     */
    public static final org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl SPEC_NAMESPACE_SET = new org.apache.ws.muws.v1_0.impl.WsdmNamespaceVersionHolderImpl();
    /**
     * A constant for the JNDI Lookup name for this home. *
     */
    public static final String HOME_LOCATION =
            org.apache.ws.resource.JndiConstants.CONTEXT_NAME_SERVICES + "/" + SERVICE_NAME.getLocalPart() + "/" + org.apache.ws.resource.JndiConstants.ATOMIC_NAME_HOME;

    /**
     * TODO
     *
     * @param resourceContext DOCUMENT_ME
     * @return DOCUMENT_ME
     * @throws ResourceException        DOCUMENT_ME
     * @throws ResourceContextException DOCUMENT_ME
     * @throws ResourceUnknownException DOCUMENT_ME
     */
    public Resource getInstance(ResourceContext resourceContext)
            throws ResourceException,
                   ResourceContextException,
                   ResourceUnknownException
    {
        ResourceKey key = resourceContext.getResourceKey();
        IpmiserverResource resource = null;
        try
        {
            resource = (IpmiserverResource)find(key);
        }
        catch (ResourceException re)
        {
            Object id = key.getValue();
            /**
             * Determine if the passed-in key is, in fact, something we expect.
             */
            if (id.equals("ipmi1") || id.equals("ipmi2"))
            {
                try
                {
                    resource = (IpmiserverResource)createInstance(key);
                    EndpointReference epr = getEndpointReference(resourceContext.getBaseURL(  ) + "/" + getServiceName().getLocalPart() , key, SPEC_NAMESPACE_SET.getAddressingNamespace());
                    resource.setEndpointReference(epr);                    
                }
                catch (Exception e)
                {
                    throw new ResourceException(e);
                }
                add(key, resource);
            }
            else
            {
                throw new ResourceUnknownException(id,
                                                   resourceContext.getServiceName());
            }
        }
        return resource;
    }

    public QName getServiceName()
    {
        return SERVICE_NAME;
    }

    public QName getPortType()
    {
        return PORT_TYPE;
    }

    public String getServicePortName()
    {
        return PORT_NAME;
    }

    public QName getResourceKeyNameQName()
    {
        return RESOURCE_KEY_NAME;
    }
}
