package org.everest;

import org.apache.ws.XmlObjectWrapper;
import org.apache.ws.mows.v1_0.MowsConstants;
import org.apache.ws.muws.impl.CategoryImpl;
import org.apache.ws.muws.v1_0.MuwsConstants;
import org.apache.ws.muws.v1_0.events.Situation;
import org.apache.ws.muws.v1_0.events.impl.SituationImpl;
import org.apache.ws.muws.v1_0.events.impl.XmlBeansManagementEvent;
import org.apache.ws.notification.topics.Topic;
import org.apache.ws.resource.ResourceContext;
import org.apache.ws.resource.example.InteropConstants;
import org.apache.ws.resource.impl.SimpleTypeResourceKey;
import org.apache.ws.util.XmlBeanUtils;
import org.apache.xmlbeans.XmlObject;
import org.everestWeather.wsdm.samples.x2005.x04.schema.WeatherstationHome;
import org.everestWeather.wsdm.samples.x2005.x04.schema.WeatherstationPropertyQNames;
import org.everestWeather.wsdm.samples.x2005.x04.schema.WeatherstationResource;
import org.oasisOpen.docs.wsdm.x2004.x12.mows.wsdmMows.AnyXmlContentsType;
import org.oasisOpen.docs.wsdm.x2004.x12.mows.wsdmMows.GetManageabilityReferencesDocument;
import org.oasisOpen.docs.wsdm.x2004.x12.mows.wsdmMows.GetManageabilityReferencesResponseDocument;
import org.oasisOpen.docs.wsdm.x2004.x12.mows.wsdmMows.MessageContentType;
import org.oasisOpen.docs.wsdm.x2004.x12.mows.wsdmMows.MessageInformationType;
import org.oasisOpen.docs.wsdm.x2004.x12.mows.wsdmMows.RequestProcessingNotificationDocument;
import org.oasisOpen.docs.wsdm.x2004.x12.mows.wsdmMows.RequestProcessingStateInformationType;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart1.ManagementEventDocument;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.StateTransitionType;
import org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart2.StateType;
import org.xmlsoap.schemas.ws.x2004.x08.addressing.AttributedURI;
import org.xmlsoap.schemas.ws.x2004.x08.addressing.EndpointReferenceType;
import org.xmlsoap.schemas.ws.x2004.x08.addressing.ReferencePropertiesType;

import javax.naming.InitialContext;
import javax.xml.namespace.QName;
import java.util.Calendar;

/**
 * This class should be generated ONCE (and not overwritten) to maintain user-added code. If there is a change to the
 * WSDL, then the generated implemented interfaces (representing the "base" portTypes) will change, thus showing a
 * compile error to the user.
 * <p/>
 * NOTE: This class is generated. However, it will not be overwritten by subsequent calls to the code generator.
 */
public class WeatherStationSoapService
        extends AbstractWeatherStationSoapService
        implements WeatherStationSoapCustomOperationsPortType
{

    private ResourceContext m_resourceContext;

    /**
     * Creates a new {@link WeatherStationSoapService } object.
     *
     * @param resourceContext DOCUMENT_ME
     */
    public WeatherStationSoapService(ResourceContext resourceContext)
    {
        m_resourceContext = resourceContext;
        init();
    }

    /**
     * DOCUMENT_ME
     *
     * @return DOCUMENT_ME
     */
    public ResourceContext getResourceContext()
    {
        return m_resourceContext;
    }

    public GetManageabilityReferencesResponseDocument getManageabilityReferences(GetManageabilityReferencesDocument request)
    {
        GetManageabilityReferencesResponseDocument getManageabilityReferencesResponseDocument = GetManageabilityReferencesResponseDocument.Factory.newInstance();
        GetManageabilityReferencesResponseDocument.GetManageabilityReferencesResponse getManageabilityReferencesResponse = getManageabilityReferencesResponseDocument.addNewGetManageabilityReferencesResponse();
        QName resourceKeyName = QName.valueOf("{" + WeatherstationPropertyQNames.FCCID.getNamespaceURI() + "}ResourceID");
        EndpointReferenceType endpointReferenceType = getManageabilityReferencesResponse.addNewManageabilityEndpointReference();
        AttributedURI attributedURI = endpointReferenceType.addNewAddress();
        attributedURI.setStringValue(InteropConstants.SERVICES_URL + "/" + InteropConstants.WEATHERSTATION_SERVICE_NAME);
        ReferencePropertiesType referencePropertiesType = endpointReferenceType.addNewReferenceProperties();
        XmlObject key1 = XmlBeanUtils.addChildElement(referencePropertiesType, resourceKeyName);
        XmlBeanUtils.setValue(key1, InteropConstants.WEATHERSTATION_KEY1);

        EndpointReferenceType endpointReferenceType2 = getManageabilityReferencesResponse.addNewManageabilityEndpointReference();
        attributedURI = endpointReferenceType2.addNewAddress();
        attributedURI.setStringValue(InteropConstants.SERVICES_URL + "/" + InteropConstants.WEATHERSTATION_SERVICE_NAME);
        referencePropertiesType = endpointReferenceType2.addNewReferenceProperties();
        key1 = XmlBeanUtils.addChildElement(referencePropertiesType, resourceKeyName);
        XmlBeanUtils.setValue(key1, InteropConstants.WEATHERSTATION_KEY2);

        return getManageabilityReferencesResponseDocument;
    }

    public org.everest.GetCurrentTemperatureResponseDocument GetCurrentTemperature(org.everest.GetCurrentTemperatureDocument getCurrentTemperatureRequestDoc)
    {
        GetCurrentTemperatureResponseDocument getCurrentTemperatureResponseDocument = GetCurrentTemperatureResponseDocument.Factory.newInstance();
        GetCurrentTemperatureResponseDocument.GetCurrentTemperatureResponse getCurrentTemperatureResponse = getCurrentTemperatureResponseDocument.addNewGetCurrentTemperatureResponse();
        Double aDouble = new Double(101);
        getCurrentTemperatureResponse.setGetCurrentTemperatureResult(aDouble.doubleValue());

        try
        {
            InitialContext initialContext = new InitialContext();
            WeatherstationHome home = (WeatherstationHome) initialContext.lookup(WeatherstationHome.HOME_LOCATION);
            SimpleTypeResourceKey simpleTypeResourceKey = new SimpleTypeResourceKey(new QName(WeatherstationPropertyQNames.FCCID.getNamespaceURI(), "ResourceID"),
                                                                                    InteropConstants.WEATHERSTATION_KEY1);
            WeatherstationResource resource = (WeatherstationResource) home.find(simpleTypeResourceKey);
            Topic topic = resource.getTopicSpaceSet().getTopicSpace(MowsConstants.NSURI_MOWS_TOPICS).getTopic("RequestProcessingObservations");
            Calendar currentTime = Calendar.getInstance();

            //RequestProcessingNotification
            RequestProcessingNotificationDocument notifDocument = RequestProcessingNotificationDocument.Factory.newInstance();
            RequestProcessingNotificationDocument.RequestProcessingNotification notif = notifDocument.addNewRequestProcessingNotification();

            //request message
            MessageInformationType requestInformationType = notif.addNewRequest();
            MessageContentType requestMessage = requestInformationType.addNewMessage();
            AnyXmlContentsType requestAnyXmlContentsType = requestMessage.addNewXml();
            XmlBeanUtils.addChildElement(requestAnyXmlContentsType, getCurrentTemperatureRequestDoc);

            //reply message
            MessageInformationType replyInformationType = notif.addNewReply();
            MessageContentType replyMessage = replyInformationType.addNewMessage();
            AnyXmlContentsType replyAnyXmlContentsType = replyMessage.addNewXml();
            XmlBeanUtils.addChildElement(replyAnyXmlContentsType, getCurrentTemperatureResponseDocument);

            //todo flesh out
            //StateInformation
            RequestProcessingStateInformationType requestProcessingStateInformationType = notif.addNewStateInformation();
            StateTransitionType stateTransitionType = requestProcessingStateInformationType.addNewStateTransition();

            XmlObject currentState = XmlObject.Factory.parse("<tns:temp xmlns:tns=\"http://tempcentral.com/temps\">Cool</tns:temp>");

            StateType enteredState = stateTransitionType.addNewEnteredState();
            XmlBeanUtils.addChildElement(enteredState, currentState);

            StateType prevState = stateTransitionType.addNewPreviousState();
            XmlBeanUtils.addChildElement(prevState, currentState);

            stateTransitionType.setTransitionIdentifier("urn:NONE");
            stateTransitionType.setTime(currentTime);
            notif.setCurrentTime(currentTime);

            Situation situation = new SituationImpl(new CategoryImpl(MuwsConstants.SITUATION_OTHER));
            XmlBeansManagementEvent xme = new XmlBeansManagementEvent(situation);
            ManagementEventDocument mgmtEvent = (ManagementEventDocument) ((XmlObjectWrapper) xme).getXmlObject();
            org.oasisOpen.docs.wsdm.x2004.x12.muws.wsdmMuwsPart1.ManagementEventType managementEvent = mgmtEvent.getManagementEvent();
            XmlBeanUtils.addChildElement(managementEvent, notifDocument);

            topic.publish(mgmtEvent);
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }

        return getCurrentTemperatureResponseDocument;
    }

}
